package com.shadeslider.project.views 
{
    import com.shadeslider.base.*;
    import com.shadeslider.project.consts.*;
    import com.shadeslider.project.events.*;
    import com.shadeslider.project.models.*;
    import com.shadeslider.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.net.*;
    import flash.text.*;
    import flash.utils.*;
    
    public class ScrollerView extends com.shadeslider.base.CompositeView
    {
        public function ScrollerView(arg1:flash.display.MovieClip, arg2:com.shadeslider.project.models.MainModel, arg3:Object, arg4:Object=null)
        {
            super(arg1, arg2, arg3);
            this.addStageListeners();
            this.update();
            this.itemType = arg4.itemType;
            return;
        }

        protected override function update(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            return;
        }

        private function stopSliding():void
        {
            flash.utils.clearInterval(this.slidingIntervalId);
            return;
        }

        private function performSliding(arg1:String):Function
        {
            var lDelay:Number;
            var lDuration:Number;
            var lElapsedTime:Number;
            var lRepeat:Number;
            var lScrollDir:Number;
            var lScrollStep:Number;
            var lScrollTimer:flash.utils.Timer;
            var lStartY:Number;
            var pDir:String;

            var loc1:*;
            lStartY = NaN;
            lScrollStep = NaN;
            lScrollDir = NaN;
            lElapsedTime = NaN;
            lDuration = NaN;
            lDelay = NaN;
            pDir = arg1;
            lStartY = this.itemsSC.y;
            lScrollStep = config.scrollStep;
            lScrollDir = pDir != ITEMS_SLIDE_DOWN ? -1 : 1;
            lElapsedTime = 0;
            lDuration = config.scrollAnimDuration;
            lDelay = 1000 / 60;
            lRepeat = Math.ceil(lDuration / 1000 * 1000 / lDelay);
            lScrollTimer = new flash.utils.Timer(lDelay, lRepeat);
            lScrollTimer.addEventListener(flash.events.TimerEvent.TIMER, function (arg1:flash.events.TimerEvent):void
            {
                if (lElapsedTime > lDuration || lElapsedTime / lDuration > 0.95)
                {
                    lElapsedTime = lDuration;
                }
                itemsSC.y = com.shadeslider.utils.Easing.easeInOutQuart(lElapsedTime, lStartY, lScrollStep * lScrollDir, lDuration);
                lElapsedTime = lElapsedTime + Number(lDelay.toFixed(1));
                return;
            })
            lScrollTimer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, function (arg1:flash.events.Event):void
            {
                currentItem = currentItem + lScrollDir;
                currentItemUrl = modelItems[currentItem].url;
                slidingTimerRunning = false;
                itemsHitAreaRollOverHandler(new flash.events.MouseEvent(flash.events.MouseEvent.ROLL_OVER));
                if (queueScrolling)
                {
                    startSliding(queueScrolling);
                    queueScrolling = null;
                }
                if (itemsSC.y < 0)
                {
                    if (stageClip.arrowUp.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeOut(stageClip.arrowUp, 300);
                    }
                }
                else 
                {
                    if (!stageClip.arrowUp.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeIn(stageClip.arrowUp, 300);
                    }
                }
                if (itemsSC.y > itemsSC.height - 157)
                {
                    if (stageClip.arrowDown.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeOut(stageClip.arrowDown, 300);
                    }
                }
                else 
                {
                    if (!stageClip.arrowDown.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeIn(stageClip.arrowDown, 300);
                    }
                }
                return;
            })
            lScrollTimer.start();
            this.slidingTimerRunning = true;
            return null;
        }

        private function addItem(arg1:Object):void
        {
            var loc1:*=null;
            var loc2:*=undefined;
            var loc5:*=this.itemType;
            switch (loc5) 
            {
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT:
                {
                    loc1 = flash.utils.getDefinitionByName("item") as Class;
                    loc2 = new loc1();
                    break;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM:
                {
                    loc1 = flash.utils.getDefinitionByName("item") as Class;
                    loc2 = new loc1();
                    break;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD:
                {
                    loc1 = flash.utils.getDefinitionByName("item") as Class;
                    loc2 = new loc1();
                    break;
                }
            }
            loc2.degreeTextClip.degreeText.text = arg1.degree;
            loc2.eventName.text = arg1.name;
            var loc3:*;
            (loc3 = new flash.text.TextFormat()).bold = true;
            if (String(arg1.degree).length == 2)
            {
                loc2.degreeTextClip.x = loc2.degreeTextClip.x - 6;
            }
            if (String(arg1.degree).length == 1)
            {
                loc2.degreeTextClip.x = loc2.degreeTextClip.x - 12;
            }
            loc2.degreeTextClip.degreeText.setTextFormat(loc3);
            loc2.degreeTextClip.celciusSign.sign.setTextFormat(loc3);
            loc2.eventName.setTextFormat(loc3);
            var loc4:*=0;
            if (this.itemsSC.numChildren > 0)
            {
                loc4 = this.itemsSC.getChildAt((this.itemsSC.numChildren - 1)).y - loc2.height;
            }
            loc2.y = loc4;
            this.itemsSC.addChildAt(loc2, arg1.idx);
            return;
        }

        public override function initDefaultAppearance():void
        {
            var lDelay:Number;
            var lDuration:Number;
            var lElapsedTime:Number;
            var lInt:int;
            var lRepeat:Number;
            var lScrollDir:Number;
            var lScrollStep:Number;
            var lScrollTimer:flash.utils.Timer;
            var lStartY:Number;
            var rndDuration:Number;
            var rndItem:Number;
            var rndStep:Number;

            var loc1:*;
            lStartY = NaN;
            lScrollStep = NaN;
            lScrollDir = NaN;
            lElapsedTime = NaN;
            lDuration = NaN;
            lDelay = NaN;
            stageClip.itemsList.items.y = -7;
            this.itemsSC = stageClip.itemsList.items;
            lInt = (this.itemsSC.numChildren - 1);
            while (lInt >= 0) 
            {
                this.itemsSC.removeChildAt(lInt);
                lInt = (lInt - 1);
            }
            lInt = 0;
            while (lInt < this.modelItems.length) 
            {
                this.addItem(this.modelItems[lInt]);
                lInt = (lInt + 1);
            }
            stageClip.arrowUp.buttonMode = true;
            stageClip.arrowUp.useHandCursor = true;
            stageClip.arrowDown.buttonMode = true;
            stageClip.arrowDown.useHandCursor = true;
            rndStep = Math.round(Math.random() * 100 / 10) + 5;
            rndDuration = Math.round(Math.random() * 100 / 0.05) + 1000;
            lStartY = this.itemsSC.y;
            rndItem = com.shadeslider.utils.Utils.randomInRange(5, this.modelItems.length / 2);
            lScrollStep = rndItem * 75;
            lScrollDir = 1;
            this.currentItem = rndItem;
            this.currentItemUrl = this.modelItems[this.currentItem].url;
            lElapsedTime = 0;
            lDuration = rndDuration;
            lDelay = 1000 / 60;
            lRepeat = Math.ceil(lDuration / 1000 * 1000 / lDelay);
            lScrollTimer = new flash.utils.Timer(lDelay, lRepeat);
            lScrollTimer.addEventListener(flash.events.TimerEvent.TIMER, function (arg1:flash.events.TimerEvent):void
            {
                if (lElapsedTime > lDuration || lElapsedTime / lDuration > 0.95)
                {
                    lElapsedTime = lDuration;
                }
                itemsSC.y = com.shadeslider.utils.Easing.easeInOutQuart(lElapsedTime, lStartY, lScrollStep * lScrollDir, lDuration);
                lElapsedTime = lElapsedTime + Number(lDelay.toFixed(1));
                return;
            })
            lScrollTimer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, function (arg1:flash.events.Event):void
            {
                slidingTimerRunning = false;
                itemsHitAreaRollOverHandler(new flash.events.MouseEvent(flash.events.MouseEvent.ROLL_OVER));
                if (queueScrolling)
                {
                    startSliding(queueScrolling);
                    queueScrolling = null;
                }
                if (itemsSC.y < 0)
                {
                    if (stageClip.arrowUp.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeOut(stageClip.arrowUp, 300);
                    }
                }
                else 
                {
                    if (!stageClip.arrowUp.visible)
                    {
                        com.shadeslider.utils.VisualEffects.fadeIn(stageClip.arrowUp, 300);
                    }
                }
                return;
            })
            if (this.modelItems.length > 2 && !config.bannerSmall)
            {
                lScrollTimer.start();
                this.slidingTimerRunning = true;
            }
            else 
            {
                stageClip.arrowUp.visible = false;
            }
            if (config.bannerSmall)
            {
                rndItem = com.shadeslider.utils.Utils.randomInRange(1, this.modelItems.length / 2);
                this.itemsSC.y = rndItem * 75 - 7;
                this.currentItemUrl = this.modelItems[rndItem].url;
                stageClip.arrowUp.visible = false;
                stageClip.arrowDown.visible = false;
            }
            return;
        }

        private function arrowMouseOutHandler(arg1:flash.events.MouseEvent):void
        {
            this.stopSliding();
            var loc1:*=arg1.target.name != "arrowUp" ? ITEMS_SLIDE_DOWN : ITEMS_SLIDE_UP;
            if (loc1 == this.queueScrolling)
            {
                this.queueScrolling = null;
            }
            return;
        }

        private function itemsHitAreaRollOverHandler(arg1:flash.events.MouseEvent):void
        {
            stageClip.itemsList.itemsHitArea.buttonMode = !this.slidingTimerRunning;
            stageClip.itemsList.itemsHitArea.useHandCursor = !this.slidingTimerRunning;
            return;
        }

        private function arrowMouseOverHandler(arg1:flash.events.MouseEvent):void
        {
            var loc1:*=arg1.target.name != "arrowUp" ? ITEMS_SLIDE_DOWN : ITEMS_SLIDE_UP;
            if (this.slidingTimerRunning)
            {
                this.queueScrolling = loc1;
                return;
            }
            this.startSliding(loc1);
            return;
        }

        private function get modelItems():Array
        {
            var loc1:*=this.itemType;
            switch (loc1) 
            {
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT:
                {
                    return model.itemsHot;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM:
                {
                    return model.itemsWarm;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD:
                {
                    return model.itemsCold;
                }
                default:
                {
                    return model.itemsHot;
                }
            }
        }

        private function set currentItem(arg1:int):void
        {
            var loc1:*=this.itemType;
            switch (loc1) 
            {
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT:
                {
                    model.currentItemHot = arg1;
                    break;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM:
                {
                    model.currentItemWarm = arg1;
                    break;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD:
                {
                    model.currentItemCold = arg1;
                    break;
                }
                default:
                {
                    model.currentItemHot = arg1;
                }
            }
            return;
        }

        private function addStageListeners():void
        {
            stageClip.arrowUp.addEventListener(flash.events.MouseEvent.MOUSE_OVER, this.arrowMouseOverHandler);
            stageClip.arrowUp.addEventListener(flash.events.MouseEvent.MOUSE_OUT, this.arrowMouseOutHandler);
            stageClip.arrowDown.addEventListener(flash.events.MouseEvent.MOUSE_OVER, this.arrowMouseOverHandler);
            stageClip.arrowDown.addEventListener(flash.events.MouseEvent.MOUSE_OUT, this.arrowMouseOutHandler);
            stageClip.itemsList.itemsHitArea.addEventListener(flash.events.MouseEvent.CLICK, this.itemsHitAreaClickHandler);
            stageClip.itemsList.itemsHitArea.addEventListener(flash.events.MouseEvent.ROLL_OVER, this.itemsHitAreaRollOverHandler);
            return;
        }

        protected override function modelState(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            var loc1:*=model.APP_STATE;
            switch (loc1) 
            {
                case com.shadeslider.project.events.ApplicationStates.ITEMS_LOADED:
                {
                    this.initDefaultAppearance();
                    break;
                }
            }
            return;
        }

        private function itemsHitAreaClickHandler(arg1:flash.events.MouseEvent):void
        {
            if (!this.slidingTimerRunning)
            {
                flash.net.navigateToURL(new flash.net.URLRequest(this.currentItemUrl), "_blank");
            }
            return;
        }

        private function startSliding(arg1:String):void
        {
            this.performSliding(arg1);
            this.slidingIntervalId = flash.utils.setInterval(this.performSliding, config.scrollAnimDelay + config.scrollAnimDuration, arg1);
            return;
        }

        private function get currentItem():int
        {
            var loc1:*=this.itemType;
            switch (loc1) 
            {
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT:
                {
                    return model.currentItemHot;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM:
                {
                    return model.currentItemWarm;
                }
                case com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD:
                {
                    return model.currentItemCold;
                }
                default:
                {
                    return model.currentItemHot;
                }
            }
        }

        private static const ITEMS_SLIDE_UP:String="ITEMS_SLIDE_UP";

        private static const ITEMS_SLIDE_DOWN:String="ITEMS_SLIDE_DOWN";

        private var slidingIntervalId:uint;

        private var slidingTimerRunning:Boolean=false;

        private var itemsSC:flash.display.MovieClip;

        private var currentItemUrl:String;

        private var queueScrolling:String=null;

        private var itemType:String;
    }
}
